import { ParseError } from './state.js'
import { curry } from '../vendor/izuna/src/index.js'
import { fork, succeed } from './fn.js'

/** @import { Result } from '../vendor/kojima/src/index.js' */
/** @import { ParserState } from './state.js' */

export const maybe = curry(
  /**
    * @param {(...args: any[]) => Result<ParserState, ParseError>} parser
    * @param {ParserState} state
    */
  (parser, state) => {
    const [original, clone] = fork(state)
    const result = parser(clone)
    return result.isOk() ? result : succeed([], original)
  })

